REM IDE for Pebble language and compiler
REM Geek Basic 2022 http://www.basicgames.xyz

'$INCLUDE: 'QB.BI'

LET datax = 80
LET datay = 200

DIM ascii(datax, datay)
DIM SHARED regs AS regtypex

LET cursorx = 1
LET cursory = 1
LET scrollamount = 1

COLOR 0, 15

CLS

COLOR 15,1
PRINT "Pebble IDE"
COLOR 1,15
PRINT
PRINT "Geek Basic 2022"
PRINT "http://www.basicgames.xyz"
PRINT "ptrworkmails@gmail.com"
PRINT
PRINT "Works with files up 80x200. Tabs display as spaces."
PRINT
PRINT "Controls:"
PRINT "Backspace deletes a character, moving the cursor back."
PRINT "Delete clears a line and moves up the text below it."
PRINT "Enter moves down a row to the first column."
PRINT "Insert adds a line in between lines."
PRINT "End moves the cursor to the last character on the line."
PRINT "Home moves the cursor to the beginning of the line."
PRINT "Arrow keys move the cursor.
PRINT "The left mouse button moves the cursor and selects buttons."
PRINT "F5 or left+right mouse button to copy line"
PRINT "F6 or right mouse button to paste line"
PRINT "A line must be selected before using copy or paste."
PRINT "Escape key exits the program."
PRINT
PRINT "Press any key to begin..."
COlOR 0

SLEEP

GOSUB setupmouse

LET char$ = INKEY$
LET char$ = CHR$(0)

CLS

DO

	IF char$ = CHR$(0) + "H" THEN

		IF cursory > 1 THEN

			LET cursory = cursory - 1

		ELSE

			IF scrollamount > 1 THEN

				LET scrollamount = scrollamount - 1

			END IF

		END IF

	ELSEIF char$ = CHR$(0) + "M" THEN

		LET cursorx = cursorx + 1

		IF cursorx >= 80 THEN

			LET cursorx = 1

		END IF

	ELSEIF char$ = CHR$(0) + "P" OR char$ = CHR$(13) THEN

		IF cursory < 22 THEN

			LET cursory = cursory + 1
 
		ELSE

			IF scrollamount < datay - 21 THEN

				LET scrollamount = scrollamount + 1

			END IF

		END IF

		IF char$ = CHR$(13) THEN

			LET cursorx = 1

		END IF

	ELSEIF char$ = CHR$(0) + "K" THEN

		IF cursorx > 1 THEN

			LET cursorx = cursorx - 1
	 
		END IF

	ELSEIF char$ = CHR$(0) + "R" THEN

		FOR sy = datay - 1 TO cursory + scrollamount - 1 STEP -1

			FOR sx = 0 TO 80

				IF sy = cursory + scrollamount - 1 THEN

					LET ascii(sx, sy) = 0

				ELSE

					LET ascii(sx, sy) = ascii(sx, sy - 1)

				END IF

			NEXT sx

		NEXT sy

	ELSEIF char$ = CHR$(0) + "G" THEN

		LET cursorx = 1

	ELSEIF char$ = CHR$(0) + "O" THEN

		FOR sx = 80 TO 1 STEP -1

			IF ascii(sx, cursory) <> 0 AND ascii(sx, cursory) <> 32 THEN

				LET cursorx = sx + 1
				EXIT FOR

			END IF

		NEXT sx

	ELSEIF char$ = CHR$(0) + "S" THEN

		FOR sy = cursory + scrollamount - 1 TO datay - 1

			FOR sx = cursorx - 1 TO 80

				IF sy = datay - 1 THEN

					LET ascii(sx, sy) = 0

				ELSE

					LET ascii(sx, sy) = ascii(sx, sy + 1)

				END IF

			NEXT sx

		NEXT sy

	ELSEIF char$ = CHR$(8) THEN

		LET ascii(cursorx - 1, (scrollamount + cursory) - 1) = 0

		IF cursorx > 1 THEN

			LET cursorx = cursorx - 1
	 
		ELSE

			LET cursorx = 80

			IF cursory > 1 THEN

				LET cursory = cursory - 1

			ELSE

				IF scrollamount > 1 THEN

					LET scrollamount = scrollamount - 1

				END IF

			END IF

		END IF

	ELSEIF char$ = CHR$(0) + ";" THEN

		CLS

		LINE INPUT "New file? (y/n) "; confirm$

		IF UCASE$(confirm$) = "Y" THEN

			CLS

			LET cursorx = 1
			LET cursory = 1
			LET scrollamount = 1

			GOSUB cleardata

		END IF

	ELSEIF char$ = CHR$(0) + "<" THEN

		CLS

		LINE INPUT "Save file as? "; textfile$

		IF textfile$ <> "" THEN

			FOR py = datay TO 1 STEP -1

				LET lastline = 0

				FOR px = 1 TO datax

					IF ascii(px - 1, py - 1) <> 0 AND ascii(px - 1, py - 1) <> 32 THEN

						LET lastline = py
			 			EXIT FOR

					END IF

				NEXT px

				IF lastline THEN

					EXIT FOR

				ENDIF

			NEXT py

			OPEN textfile$ FOR OUTPUT AS #1

			FOR py = 1 TO lastline

				LET textline$ = ""

				FOR px = 1 TO datax

					IF ascii(px - 1, py - 1) THEN
			 
						LET textline$ = textline$ + CHR$(ascii(px - 1, py - 1))
		 
					END IF
		 
				NEXT px

				IF py<>1 THEN

					PRINT #1, RTRIM$(textline$)

				END IF

			NEXT py

			CLOSE #1

			PRINT "File saved as " + textfile$
			PRINT "Press any key to continue editing..."
			SLEEP
			LET flush$ = INKEY$

		END IF

	ELSEIF char$ = CHR$(0) + "=" THEN

		CLS

		LINE INPUT "Open file? "; textfile$

		GOSUB loadfile
 
	ELSEIF char$ = CHR$(0) + ">" THEN

		PRINT "Compiling..."

		LET title$ = MID$(textfile$, 1, LEN(textfile$) - 4)
 
		OPEN title$ + ".bat" FOR OUTPUT AS #1
	 
		PRINT #1, "@pebble " + textfile$
		PRINT #1, "@fasm\fasmlite " + title$ + ".asm"
		PRINT #1, "@pause"
		PRINT #1, "@" + title$ + ".com"

		CLOSE #1

		CLS
		SHELL title$ + ".bat"
		CLS

	ELSEIF char$ = CHR$(0) + "@" THEN

		cls

		IF clip$<>"" THEN

			FOR copy=0 TO LEN(clip$)-2

				LET ascii(copy, (scrollamount + cursory) - 1) = ASC(MID$(clip$,copy+1,1))

			NEXT copy

		END IF

	ELSEIF char$ = CHR$(0) + "A" THEN

		LET clip$ = ""

		FOR copy=0 TO 79

			LET clip$ = clip$ + CHR$(ascii(copy, (scrollamount + cursory) - 1))

		NEXT copy

	ELSEIF char$ = CHR$(27) THEN

		CLS

		LINE INPUT "Quit to DOS? (y/n) "; confirm$

		IF UCASE$(confirm$) = "Y" THEN

			END

		END IF

	ELSEIF char$ <> CHR$(0) THEN

		LET ascii(cursorx - 1, (scrollamount + cursory) - 1) = ASC(char$)
	 
		IF cursorx < datax THEN
	 
			LET cursorx = cursorx + 1

		END IF

	END IF

	FOR py = 1 TO 22

		FOR px = 1 TO 80

			LOCATE py, px

			IF ascii(px - 1, (scrollamount + py) - 1) <> 0 AND ascii(px - 1, (scrollamount + py) - 1) <> 9 THEN

				PRINT CHR$(ascii(px - 1, (scrollamount + py) - 1))

			ELSE

				PRINT " "
	 
			END IF

		NEXT px

	NEXT py

	COLOR 1
	LOCATE 23, 1
	PRINT "*Pebble IDE* [New F1] [Save F2] [Open F3] [Run F4] [Exit] Column:"; cursorx; "Row:"; cursory + scrollamount - 1
	COLOR 0

	DO

		IF TIMER > delay + .7 THEN

			IF blink = 0 THEN

				LET blink = 1

			ELSE

				LET blink = 0

			END IF

			LET delay = TIMER

		END IF

		IF blink = 0 THEN

			LOCATE cursory, cursorx

			IF ascii(cursorx - 1, (scrollamount + cursory) - 1) <> 9 THEN

				PRINT CHR$(ascii(cursorx - 1, (scrollamount + cursory) - 1))

			ELSE

				PRINT " "

			END IF

		ELSE

			LOCATE cursory, cursorx
			PRINT CHR$(219)

		END IF

		LET char$ = INKEY$

		GOSUB readmouse

		IF mouseb=1 THEN

			IF mousey<23 THEN

				LET cursorx = mousex
				LET cursory = mousey
				LET char$ = CHR$(0)

			ELSEIF mousey=23 THEN

				IF mousex>=14 AND mousex<=21 THEN

					LET char$ = CHR$(0) + ";"

				END IF

				IF mousex>=23 AND mousex<=31 THEN

					LET char$ = CHR$(0) + "<"

				END IF

				IF mousex>=33 AND mousex<=41 THEN

					LET char$ = CHR$(0) + "="

				END IF

				IF mousex>=43 AND mousex<=50 THEN

					LET char$ = CHR$(0) + ">"

				END IF

				IF mousex>=52 AND mousex<=57 THEN

					LET char$ = CHR$(27)

				END IF

			END IF

		ELSEIF mouseb=2 THEN

			LET char$ = CHR$(0) + "@"
			
		ELSEIF mouseb=3 THEN

			LET char$ = CHR$(0) + "A"

		END IF

	LOOP UNTIL char$ <> ""

LOOP

loadfile:

	IF textfile$ <> "" THEN

		OPEN textfile$ FOR INPUT AS #1

		LET cursorx = 1
		LET cursory = 1
		LET scrollamount = 1

		GOSUB cleardata

		FOR py = 1 TO datay

			IF EOF(1) = 0 THEN
		
				LINE INPUT #1, textline$
		
				FOR px = 1 TO LEN(textline$)

					LET ascii(px - 1, py) = ASC(MID$(textline$, px, 1))
	
				NEXT px

			ELSE

				EXIT FOR

			END IF

		NEXT py

	END IF

	CLOSE #1

RETURN

cleardata:

	FOR py = 1 TO datay

		FOR px = 1 TO datax

			LET ascii(px - 1, py - 1) = 0

		NEXT px

	NEXT py

RETURN

setupmouse:

	PRINT "Setting up mouse..."

	LET regs.ax = 0
	CALL INTERRUPTX(51, regs, regs)

	LET regs.ax = 1
	CALL INTERRUPTX(51, regs, regs)

RETURN

readmouse:

	LET regs.ax = 3
	CALL INTERRUPTX(51, regs, regs)

	LET mousex = INT(regs.cx/8)+1
	LET mousey = INT(regs.dx/8)+1
	LET mouseb = regs.bx

RETURN